Status: Closed Start date:

Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: Performance Estimated time: 0.00 hour
Target version: 4.0.0

Resolution: Fixed

Description

On setups where a lot of logins happen (e.g. when heavily using the AP with Basic Auth credentials), access to the@ users@ table
can get contentioned due to the many parallel write queries to the table during each request as each requests sets the last_login_on
column of the user to the current date in User.try_to_login. This can result in deadlocks or general long lock waits on the database
since all of these update queries will effectively be serialized per user.

By updating the last_login_on column less often, we can drastically reduce this contention. The attached patch implements this by
only updating the last_login_on column once per minute.

Related issues:
Related to Redmine - Defect #20648: Users' "Last connection" is not updated c... Closed
Related to Redmine - Feature #29041: Update session token only once per minute Closed

Associated revisions

Revision 17403 - 2018-06-17 16:51 - Jean-Philippe Lang

Update User#last_login_on only once per minute and user to reduce DB lock contention on users table (#28952).

Patch by Holger Just.

History

#1 - 2018-06-05 13:31 - Go MAEDA

- Target version set to Candidate for next major release

#2 - 2018-06-05 15:25 - Pavel Rosicky

nice catch!

I'm wondering if something like this could be also applied for

verify_session_token - https://github.com/redmine/redmine/blob/43d9bea7c5da32a99c3ebdb828e23d6a02c¢31c12/app/models/user.rb#l 442

if Rails.application.config.redmine_verify_sessions is enabled, redmine updates user tokens on each request. These updates are at the top or our db
monitoring.

#3 - 2018-06-06 03:00 - Go MAEDA

- Related to Defect #20648: Users' "Last connection" is not updated correctly. added

#4 - 2018-06-08 03:02 - Go MAEDA

- Target version changed from Candidate for next major release to 4.1.0

+1
Sometimes | also experience the same problem.

Setting target version to 4.1.0.

#5 - 2018-06-09 11:49 - Go MAEDA

- Category set to Performance

#6 - 2018-06-17 16:54 - Jean-Philippe Lang

- Status changed from New to Closed
https://github.com/redmine/redmine/blob/43d9bea7c5da32a99c3ebdb828e23d6a02c31c12/app/models/user.rb#L442

- Assignee set to Jean-Philippe Lang

- Target version changed from 4.1.0 to 4.0.0
- Resolution set to Fixed

Patch committed, thanks.

Pavel Rosicky wrote:

I'm wondering if something like this could be also applied for

verify_session_token - https:/github.com/redmine/redmine/blob/43d9bea7c5da32a99¢c3ebdb828e23d6a02c¢31c12/app/models/user.rb#l 442

if Rails.application.config.redmine_verify_sessions is enabled, redmine updates user tokens on each request. These updates are at the top or

our db monitoring.

Please fill a separate issue so we can keep track of that.

#7 - 2018-06-17 20:00 - Pavel Rosicky
done #29041

#8 - 2018-06-17 20:43 - Marius BALTEANU

- Related to Feature #2904 1: Update session token only once per minute added
